Botan: Botan::CTR_BE Class Reference

Botan 1.10.16

Public Member Functions | List of all members
Botan::CTR_BE Class Reference

`#include <ctr.h>`

Inheritance diagram for Botan::CTR_BE:

## Public Member Functions
void | cipher (const byte in[], byte out[], size_t length)
void | cipher1 (byte buf[], size_t len)
void | clear ()
CTR_BE * | clone () const
| CTR_BE (BlockCipher *cipher)
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
void | set_iv (const byte iv[], size_t iv_len)
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_iv_length (size_t iv_len) const
bool | valid_keylength (size_t length) const
| ~CTR_BE ()

## Detailed Description

CTR-BE (Counter mode, big-endian)

Definition at line 19 of file ctr.h.

## Constructor & Destructor Documentation

## ◆ CTR_BE()

Botan::CTR_BE::CTR_BE | ( | BlockCipher * | cipher | ) |

Parameters

  cipher | the underlying block cipher to use

Definition at line 17 of file ctr.cpp.

17 :
18 permutation(ciph),
19 counter(256 * permutation->block_size()),
20 buffer(counter.size()),
21 position(0)
22 {
23 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ ~CTR_BE()

Botan::CTR_BE::~CTR_BE | ( |  | ) |

Definition at line 28 of file ctr.cpp.

29 {
30 delete permutation;
31 }

## Member Function Documentation

## ◆ cipher()

void Botan::CTR_BE::cipher | ( | const byte | in[],
|  | byte | out[],
|  | size_t | len
| ) |  |
| virtual

Encrypt or decrypt a message

Parameters

  in | the plaintext
  out | the byte array to hold the output, i.e. the ciphertext
  len | the length of both in and out in bytes

Implements Botan::StreamCipher.

Definition at line 66 of file ctr.cpp.

References Botan::MemoryRegion< T >::size(), and Botan::xor_buf().

67 {
68 while(length >= buffer.size() - position)
69 {
70 xor_buf(out, in, &buffer[position], buffer.size() - position);
71 length -= (buffer.size() - position);
72 in += (buffer.size() - position);
73 out += (buffer.size() - position);
74 increment_counter();
75 }
76 xor_buf(out, in, &buffer[position], length);
77 position += length;
78 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::xor_buf
void xor_buf(byte out[], const byte in[], size_t length)
Definition: xor_buf.h:21

## ◆ cipher1()

void Botan::StreamCipher::cipher1 | ( | byte | buf[],
|  | size_t | len
| ) |  |
| inlineinherited

Encrypt or decrypt a message

Parameters

  buf | the plaintext / ciphertext
  len | the length of buf in bytes

Definition at line 34 of file stream_cipher.h.

Referenced by Botan::Lion::decrypt_n(), and Botan::Lion::encrypt_n().

35 { cipher(buf, buf, len); }
Botan::StreamCipher::cipher
virtual void cipher(const byte in[], byte out[], size_t len)=0

## ◆ clear()

void Botan::CTR_BE::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 36 of file ctr.cpp.

References Botan::Algorithm::clear(), set_iv(), Botan::SymmetricAlgorithm::set_key(), and Botan::zeroise().

37 {
38 permutation->clear();
39 zeroise(buffer);
40 zeroise(counter);
41 position = 0;
42 }
Botan::Algorithm::clear
virtual void clear()=0
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:415

## ◆ clone()

CTR_BE* Botan::CTR_BE::clone | ( |  | ) | const
| inlinevirtual

Get a new object representing the same algorithm as *this

Implements Botan::StreamCipher.

Definition at line 36 of file ctr.h.

37 { return new CTR_BE(permutation->clone()); }
Botan::BlockCipher::clone
virtual BlockCipher * clone() const =0
Botan::CTR_BE::CTR_BE
CTR_BE(BlockCipher *cipher)
Definition: ctr.cpp:17

## ◆ key_spec()

Key_Length_Specification Botan::CTR_BE::key_spec | ( |  | ) | const
| inlinevirtual

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 29 of file ctr.h.

30 {
31 return permutation->key_spec();
32 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inlineinherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

Referenced by Botan::Cascade_Cipher::decrypt_n(), and Botan::ANSI_X931_RNG::randomize().

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inlineinherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::CTR_BE::name | ( |  | ) | const
| virtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 58 of file ctr.cpp.

References Botan::Algorithm::name().

Referenced by set_iv().

59 {
60 return ("CTR-BE(" + permutation->name() + ")");
61 }
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ set_iv()

void Botan::CTR_BE::set_iv | ( | const byte | iv[],
|  | size_t | iv_len
| ) |  |
| virtual

Resync the cipher using the IV

Parameters

  iv | the initialization vector
  iv_len | the length of the IV in bytes

Reimplemented from Botan::StreamCipher.

Definition at line 83 of file ctr.cpp.

References Botan::BlockCipher::block_size(), Botan::MemoryRegion< T >::copy(), Botan::BlockCipher::encrypt_n(), name(), valid_iv_length(), and Botan::zeroise().

Referenced by clear().

84 {
85 if(!valid_iv_length(iv_len))
86 throw Invalid_IV_Length(name(), iv_len);
87
88 const size_t bs = permutation->block_size();
89
90 zeroise(counter);
91
92 counter.copy(0, iv, iv_len);
93
94 /*
95 * Set counter blocks to IV, IV + 1, ... IV + 255
96 */
97 for(size_t i = 1; i != 256; ++i)
98 {
99 counter.copy(i*bs, &counter[(i-1)*bs], bs);
100
101 for(size_t j = 0; j != bs; ++j)
102 if(++counter[i*bs + (bs - 1 - j)])
103 break;
104 }
105
106 permutation->encrypt_n(&counter[0], &buffer[0], 256);
107 position = 0;
108 }
Botan::CTR_BE::name
std::string name() const
Definition: ctr.cpp:58
Botan::MemoryRegion::copy
void copy(const T in[], size_t n)
Definition: secmem.h:120
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:415
Botan::BlockCipher::block_size
virtual size_t block_size() const =0
Botan::CTR_BE::valid_iv_length
bool valid_iv_length(size_t iv_len) const
Definition: ctr.h:26

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), clear(), Botan::OFB::clear(), Botan::DESX::decrypt_n(), Botan::Cascade_Cipher::decrypt_n(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::HMAC_RNG::reseed(), Botan::EAX_Base::set_key(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), Botan::StreamCipher_Filter::StreamCipher_Filter(), Botan::DLIES_Decryptor::~DLIES_Decryptor(), and Botan::DLIES_Encryptor::~DLIES_Encryptor().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_iv_length()

bool Botan::CTR_BE::valid_iv_length | ( | size_t | iv_len | ) | const
| inlinevirtual

Parameters

  iv_len | the length of the IV in bytes

Returns
  if the length is valid for this algorithm

Reimplemented from Botan::StreamCipher.

Definition at line 26 of file ctr.h.

Referenced by set_iv().

27 { return (iv_len <= permutation->block_size()); }

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inlineinherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), Botan::Lion::Lion(), and Botan::Randpool::Randpool().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/stream/ctr/ctr.h
- src/stream/ctr/ctr.cpp